/** @file
 * VirtualBox API class wrapper header for IGraphicsAdapter.
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl
 * Generator: src/VBox/Main/idl/apiwrap-server.xsl
 */

/*
 * Copyright (C) 2010-2020 Oracle Corporation
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software
 * Foundation, in version 2 as it comes in the "COPYING" file of the
 * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 */

#ifndef GraphicsAdapterWrap_H_
#define GraphicsAdapterWrap_H_
#ifndef RT_WITHOUT_PRAGMA_ONCE
# pragma once
#endif

#include "VirtualBoxBase.h"
#include "Wrapper.h"

class ATL_NO_VTABLE GraphicsAdapterWrap
    : public VirtualBoxBase
    , VBOX_SCRIPTABLE_IMPL(IGraphicsAdapter)
{
    Q_OBJECT

public:
    VIRTUALBOXBASE_ADD_ERRORINFO_SUPPORT(GraphicsAdapterWrap, IGraphicsAdapter)
    DECLARE_NOT_AGGREGATABLE(GraphicsAdapterWrap)
    DECLARE_PROTECT_FINAL_CONSTRUCT()

    BEGIN_COM_MAP(GraphicsAdapterWrap)
        COM_INTERFACE_ENTRY(ISupportErrorInfo)
        COM_INTERFACE_ENTRY(IGraphicsAdapter)
        COM_INTERFACE_ENTRY2(IDispatch, IGraphicsAdapter)
        VBOX_TWEAK_INTERFACE_ENTRY(IGraphicsAdapter)
    END_COM_MAP()

    DECLARE_EMPTY_CTOR_DTOR(GraphicsAdapterWrap)

    /** @name Public IGraphicsAdapter properties
     * @{ */
    STDMETHOD(COMGETTER(GraphicsControllerType))(GraphicsControllerType_T *aGraphicsControllerType);
    STDMETHOD(COMSETTER(GraphicsControllerType))(GraphicsControllerType_T aGraphicsControllerType);
    STDMETHOD(COMGETTER(VRAMSize))(ULONG *aVRAMSize);
    STDMETHOD(COMSETTER(VRAMSize))(ULONG aVRAMSize);
    STDMETHOD(COMGETTER(Accelerate3DEnabled))(BOOL *aAccelerate3DEnabled);
    STDMETHOD(COMSETTER(Accelerate3DEnabled))(BOOL aAccelerate3DEnabled);
    STDMETHOD(COMGETTER(Accelerate2DVideoEnabled))(BOOL *aAccelerate2DVideoEnabled);
    STDMETHOD(COMSETTER(Accelerate2DVideoEnabled))(BOOL aAccelerate2DVideoEnabled);
    STDMETHOD(COMGETTER(MonitorCount))(ULONG *aMonitorCount);
    STDMETHOD(COMSETTER(MonitorCount))(ULONG aMonitorCount);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute1IGraphicsAdapter))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute2IGraphicsAdapter))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute3IGraphicsAdapter))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute4IGraphicsAdapter))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute5IGraphicsAdapter))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute6IGraphicsAdapter))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute7IGraphicsAdapter))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute8IGraphicsAdapter))(ULONG *aReserved);
    /** @} */

    /** @name Public IGraphicsAdapter methods
     * @{ */
    STDMETHOD(InternalAndReservedMethod1IGraphicsAdapter)();
    STDMETHOD(InternalAndReservedMethod2IGraphicsAdapter)();
    STDMETHOD(InternalAndReservedMethod3IGraphicsAdapter)();
    STDMETHOD(InternalAndReservedMethod4IGraphicsAdapter)();
    /** @} */

private:
    /** @name Wrapped IGraphicsAdapter properties
     * @{ */
    virtual HRESULT getGraphicsControllerType(GraphicsControllerType_T *aGraphicsControllerType) = 0;
    virtual HRESULT setGraphicsControllerType(GraphicsControllerType_T aGraphicsControllerType) = 0;
    virtual HRESULT getVRAMSize(ULONG *aVRAMSize) = 0;
    virtual HRESULT setVRAMSize(ULONG aVRAMSize) = 0;
    virtual HRESULT getAccelerate3DEnabled(BOOL *aAccelerate3DEnabled) = 0;
    virtual HRESULT setAccelerate3DEnabled(BOOL aAccelerate3DEnabled) = 0;
    virtual HRESULT getAccelerate2DVideoEnabled(BOOL *aAccelerate2DVideoEnabled) = 0;
    virtual HRESULT setAccelerate2DVideoEnabled(BOOL aAccelerate2DVideoEnabled) = 0;
    virtual HRESULT getMonitorCount(ULONG *aMonitorCount) = 0;
    virtual HRESULT setMonitorCount(ULONG aMonitorCount) = 0;
    /** @} */

    /** @name Wrapped IGraphicsAdapter methods
     * @{ */
    /** @} */

private:
    DECLARE_CLS_COPY_CTOR_ASSIGN_NOOP(GraphicsAdapterWrap); /* Shuts up MSC warning C4625. */

};

#endif // !GraphicsAdapterWrap_H_
